#include "OfflineEventViewer.h"

int OfflineEventViewer::LoadFile(const char* filename) {
    fin = fopen(filename, "r");
//    off_t tmp;
    
    if (fin == NULL) {
        return -1;   
    }
    
    // parse events
    evtOffsets.clear();
    
    off_t offset;
    while (!feof(fin) && evtOffsets.size() < 100) {
        offset = ftell(fin);
        
        char data[100];
        int linecount = 0;

        do {
            fgets(data, 100, fin);
            linecount++;
        } while ((strlen(data) > 2) && !feof(fin) );  // 1 because a null line will still contain a \n

        if (linecount >= 1024) {
		printf("event read, len=%d\n", linecount);
            evtOffsets.push_back(offset);
	}
    }  

    return evtOffsets.size();    
}

int OfflineEventViewer::ContinueLoadingFile(int limit) {
    if (feof(fin) )
        return 0;

    fseek(fin, evtOffsets.at(evtOffsets.size() - 1) , 0);
    int i = -1;
    off_t offset;
    unsigned int oldSize, newSize;
    
    oldSize = evtOffsets.size();
    
    evtOffsets.pop_back();  // it'll get readded once the first while iteration finishes
    
    while (!feof(fin) && i < limit) {
        offset = ftell(fin);
        
        char data[100];
        int linecount=0;

        do {
            fgets(data, 100, fin);
            linecount++;
        } while (strlen(data) > 2);  // 1 because a null line will still contain a \n

        if (linecount >= 1024 || i < 0)
            evtOffsets.push_back(offset);
            
        i++;
    }  

    newSize = evtOffsets.size();
    
    return newSize - oldSize;
}

int OfflineEventViewer::EventSeek(unsigned int num) {
    buffer.clear();
    char buf[100];
    
    if (num >= evtOffsets.size() )
        return -1;
        
    fseek(fin, evtOffsets.at(num), 0);
    
    buffer.push_back(0);
    buffer.push_back(0);    
    
    do {
        int val;
        fgets(buf, 100, fin);
        if (feof(fin))
            break;
        
        if (buf[0] != '#') {
               val = atoi(buf);
               buffer.push_back((unsigned short int) val );
        }
        
    } while (buf[0] >= '0');

    return buffer.size();
}

unsigned short int* OfflineEventViewer::getBuffer() {
    if (buffer.size() <= 1)
        return NULL;
        
    return &buffer[0];
}
