//---------------------------------------------------------------------------
//
// Name:        PSEC3_evalFrm.cpp
// Author:      Andrew Wong
// Created:     2/6/2008 4:51:21 PM
// Description: PSEC3_evalFrm class implementation
//
//---------------------------------------------------------------------------

#include "PSEC3_evalFrm.h"

//Do not add custom headers between
//Header Include Start and Header Include End
//wxDev-C++ designer will remove them
////Header Include Start
////Header Include End

//----------------------------------------------------------------------------
// PSEC3_evalFrm
//----------------------------------------------------------------------------
//Add Custom Events only in the appropriate block.
//Code added in other places will be removed by wxDev-C++
////Event Table Start
BEGIN_EVENT_TABLE(PSEC3_evalFrm,wxFrame)
	////Manual Code Start
	////Manual Code End
	
	EVT_CLOSE(PSEC3_evalFrm::OnClose)
	EVT_TIMER(ID_TIMERPROBE,PSEC3_evalFrm::timerProbeTimer)
	EVT_TOGGLEBUTTON(ID_TOGGLECANCEL,PSEC3_evalFrm::toggleCancelClick)
	EVT_BUTTON(ID_BTNSAVESPIKEHISTOGRAM,PSEC3_evalFrm::btnSaveSpikeHistogramClick)
	EVT_BUTTON(ID_BTNSETPEDVOLTAGE,PSEC3_evalFrm::btnSetPedVoltageClick)
	EVT_SPINCTRL(ID_SPINPEDVOLTAGE,PSEC3_evalFrm::spinPedVoltageUpdated)
	EVT_BUTTON(ID_BTNLOADPEDESTAL,PSEC3_evalFrm::btnLoadPedestalClick)
	EVT_BUTTON(ID_BTNLOADLUT,PSEC3_evalFrm::btnLoadLUTClick)
	EVT_SPINCTRL(ID_SPINTRIGGERVOLTAGE,PSEC3_evalFrm::spinTriggerVoltageUpdated)
	EVT_BUTTON(ID_BTNINIT,PSEC3_evalFrm::btnInitClick)
	EVT_BUTTON(ID_BTNCOPYSIGNAL,PSEC3_evalFrm::btnCopySignalClick)
	
	EVT_COMMAND_SCROLL(ID_SLIDERSCALE,PSEC3_evalFrm::sliderScaleScroll)
	EVT_CHECKBOX(ID_BOXENABLECH,PSEC3_evalFrm::boxEnableCHClick)
	
	EVT_COMMAND_SCROLL(ID_SLIDEROFFSET,PSEC3_evalFrm::sliderOffsetScroll)
	EVT_LISTBOX(ID_BOXACTIVECHANNEL,PSEC3_evalFrm::boxActiveChannelSelected)
	
	EVT_COMMAND_SCROLL(ID_BARSELECTEVENT,PSEC3_evalFrm::barSelectEventScroll)
	EVT_BUTTON(ID_BTNLOADLOGFILE,PSEC3_evalFrm::btnLoadLogFileClick)
	EVT_BUTTON(ID_BTNSAVELUT,PSEC3_evalFrm::btnSaveLUTClick)
	EVT_TOGGLEBUTTON(ID_BTNREADDATA,PSEC3_evalFrm::btnReadDataClick)
	EVT_BUTTON(ID_BTNSINGLEEVENT,PSEC3_evalFrm::btnSingleEventClick)
	EVT_TOGGLEBUTTON(ID_BTNSYNCUSB,PSEC3_evalFrm::btnSyncUSBClick)
	EVT_TOGGLEBUTTON(ID_BTNLOGDATA,PSEC3_evalFrm::btnLogDataClick)
	EVT_BUTTON(ID_BTNRESETEVENTCOUNTER,PSEC3_evalFrm::btnResetEventCounterClick)
	EVT_BUTTON(ID_BTNCREATELUT,PSEC3_evalFrm::btnCreateLutClick)
	EVT_BUTTON(ID_BTNSAVEPEDESTAL,PSEC3_evalFrm::btnSavePedestalClick)
	EVT_BUTTON(ID_BTNCREATEPEDESTAL,PSEC3_evalFrm::btnCreatePedestalClick)
	EVT_BUTTON(ID_BTNEXIT,PSEC3_evalFrm::btnExitClick)
END_EVENT_TABLE()
////Event Table End

PSEC3_evalFrm::PSEC3_evalFrm(wxWindow *parent, wxWindowID id, const wxString &title, const wxPoint &position, const wxSize& size, long style)
: wxFrame(parent, id, title, position, size, style)
{
	CreateGUIControls();
}

PSEC3_evalFrm::~PSEC3_evalFrm()
{
}

void PSEC3_evalFrm::CreateGUIControls()
{
	//Do not add custom code between
	//GUI Items Creation Start and GUI Items Creation End
	//wxDev-C++ designer will remove them.
	//Add the custom code before or after the blocks
	////GUI Items Creation Start

	WxPanel1 = new wxPanel(this, ID_WXPANEL1, wxPoint(0, 0), wxSize(648, 648));

	boxDisplay = new wxNotebook(WxPanel1, ID_BOXDISPLAY, wxPoint(0, 0), wxSize(640, 400), wxNB_DEFAULT);

	pageGraph = new wxPanel(boxDisplay, ID_PAGEGRAPH, wxPoint(4, 24), wxSize(632, 372));
	boxDisplay->AddPage(pageGraph, wxT("Graph"));

	pageOutput = new wxPanel(boxDisplay, ID_PAGEOUTPUT, wxPoint(4, 24), wxSize(632, 372));
	boxDisplay->AddPage(pageOutput, wxT("Raw Output"));

	rawOutput = new wxTextCtrl(pageOutput, ID_RAWOUTPUT, wxEmptyString, wxPoint(-1, 25), wxSize(631, 337), wxTE_MULTILINE, wxDefaultValidator, wxT("rawOutput"));
	rawOutput->SetMaxLength(0);
	rawOutput->AppendText(wxT("rawOutput"));
	rawOutput->SetFocus();
	rawOutput->SetInsertionPointEnd();

	boxShowRawData = new wxCheckBox(pageOutput, ID_BOXSHOWRAWDATA, wxT("Display"), wxPoint(4, 4), wxSize(97, 17), 0, wxDefaultValidator, wxT("boxShowRawData"));

	btnExit = new wxButton(WxPanel1, ID_BTNEXIT, wxT("Exit"), wxPoint(5, 446), wxSize(75, 25), 0, wxDefaultValidator, wxT("btnExit"));

	boxReadoutMode = new wxNotebook(WxPanel1, ID_BOXREADOUTMODE, wxPoint(174, 409), wxSize(464, 235), wxNB_DEFAULT);

	tabOnline = new wxPanel(boxReadoutMode, ID_TABONLINE, wxPoint(4, 24), wxSize(456, 207));
	boxReadoutMode->AddPage(tabOnline, wxT("Online"));

	btnCreatePedestal = new wxButton(tabOnline, ID_BTNCREATEPEDESTAL, wxT("Create Pedestal"), wxPoint(18, 59), wxSize(100, 25), 0, wxDefaultValidator, wxT("btnCreatePedestal"));

	btnSavePedestal = new wxButton(tabOnline, ID_BTNSAVEPEDESTAL, wxT("Save Pedestal"), wxPoint(150, 61), wxSize(98, 25), 0, wxDefaultValidator, wxT("btnSavePedestal"));

	btnCreateLut = new wxButton(tabOnline, ID_BTNCREATELUT, wxT("Create LUT"), wxPoint(19, 17), wxSize(100, 25), 0, wxDefaultValidator, wxT("btnCreateLut"));

	txtEvent = new wxStaticText(tabOnline, ID_TXTEVENT, wxT("Event #: "), wxPoint(5, 149), wxDefaultSize, 0, wxT("txtEvent"));

	btnResetEventCounter = new wxButton(tabOnline, ID_BTNRESETEVENTCOUNTER, wxT("Reset Event #"), wxPoint(193, 159), wxSize(91, 25), 0, wxDefaultValidator, wxT("btnResetEventCounter"));

	btnLogData = new wxToggleButton(tabOnline, ID_BTNLOGDATA, wxT("Log Data"), wxPoint(342, 80), wxSize(100, 25), 0, wxDefaultValidator, wxT("btnLogData"));

	btnSyncUSB = new wxToggleButton(tabOnline, ID_BTNSYNCUSB, wxT("SYNC_USB"), wxPoint(357, 5), wxSize(88, 25), 0, wxDefaultValidator, wxT("btnSyncUSB"));

	btnSingleEvent = new wxButton(tabOnline, ID_BTNSINGLEEVENT, wxT("Single Event"), wxPoint(335, 144), wxSize(110, 25), 0, wxDefaultValidator, wxT("btnSingleEvent"));

	btnReadData = new wxToggleButton(tabOnline, ID_BTNREADDATA, wxT("Continuous Readout"), wxPoint(335, 171), wxSize(110, 25), 0, wxDefaultValidator, wxT("btnReadData"));

	btnSaveLUT = new wxButton(tabOnline, ID_BTNSAVELUT, wxT("Save LUT"), wxPoint(150, 18), wxSize(97, 25), 0, wxDefaultValidator, wxT("btnSaveLUT"));

	tabOffline = new wxPanel(boxReadoutMode, ID_TABOFFLINE, wxPoint(4, 24), wxSize(456, 207));
	boxReadoutMode->AddPage(tabOffline, wxT("Offline"));

	btnLoadLogFile = new wxButton(tabOffline, ID_BTNLOADLOGFILE, wxT("Load Log File"), wxPoint(15, 13), wxSize(75, 25), 0, wxDefaultValidator, wxT("btnLoadLogFile"));

	barSelectEvent = new wxScrollBar(tabOffline, ID_BARSELECTEVENT, wxPoint(8, 45), wxSize(437, 17), wxSB_HORIZONTAL, wxDefaultValidator, wxT("barSelectEvent"));
	barSelectEvent->Enable(false);

	txtEventNum = new wxStaticText(tabOffline, ID_TXTEVENTNUM, wxT("---"), wxPoint(9, 67), wxDefaultSize, 0, wxT("txtEventNum"));

	tabScope = new wxPanel(boxReadoutMode, ID_TABSCOPE, wxPoint(4, 24), wxSize(456, 207));
	boxReadoutMode->AddPage(tabScope, wxT("Scope"));

	wxArrayString arrayStringFor_boxActiveChannel;
	boxActiveChannel = new wxListBox(tabScope, ID_BOXACTIVECHANNEL, wxPoint(6, 5), wxSize(66, 145), arrayStringFor_boxActiveChannel, wxLB_SINGLE);
	boxActiveChannel->Append(wxT("CH1"));
	boxActiveChannel->Append(wxT("CH2"));
	boxActiveChannel->Append(wxT("CH3"));
	boxActiveChannel->Append(wxT("CH4"));
	boxActiveChannel->Append(wxT("SavedCH1"));
	boxActiveChannel->Append(wxT("SavedCH2"));
	boxActiveChannel->Append(wxT("SavedCH3"));
	boxActiveChannel->Append(wxT("SavedCH4"));

	txtOffset = new wxStaticText(tabScope, ID_TXTOFFSET, wxT("Vertical Offset:"), wxPoint(87, 30), wxDefaultSize, 0, wxT("txtOffset"));

	sliderOffset = new wxSlider(tabScope, ID_SLIDEROFFSET, 0, -60, 60, wxPoint(80, 43), wxSize(358, 26), wxSL_HORIZONTAL | wxSL_SELRANGE , wxDefaultValidator, wxT("sliderOffset"));
	sliderOffset->SetRange(-60,60);
	sliderOffset->SetValue(0);

	boxEnableCH = new wxCheckBox(tabScope, ID_BOXENABLECH, wxT("Display CH"), wxPoint(88, 6), wxSize(81, 17), 0, wxDefaultValidator, wxT("boxEnableCH"));
	boxEnableCH->SetValue(true);

	txtScaling = new wxStaticText(tabScope, ID_TXTSCALING, wxT("Vertical Scaling:"), wxPoint(83, 79), wxDefaultSize, 0, wxT("txtScaling"));

	sliderScale = new wxSlider(tabScope, ID_SLIDERSCALE, 1, 1, 100, wxPoint(80, 92), wxSize(361, 28), wxSL_HORIZONTAL | wxSL_SELRANGE , wxDefaultValidator, wxT("sliderScale"));
	sliderScale->SetRange(1,100);
	sliderScale->SetValue(1);

	btnCopySignal = new wxButton(tabScope, ID_BTNCOPYSIGNAL, wxT("Copy to..."), wxPoint(88, 126), wxSize(75, 25), 0, wxDefaultValidator, wxT("btnCopySignal"));

	tabConfig = new wxPanel(boxReadoutMode, ID_TABCONFIG, wxPoint(4, 24), wxSize(456, 207));
	boxReadoutMode->AddPage(tabConfig, wxT("Config"));

	grpInit = new wxStaticBox(tabConfig, ID_GRPINIT, wxT("Init settings"), wxPoint(5, 149), wxSize(442, 50));

	btnInit = new wxButton(tabConfig, ID_BTNINIT, wxT("Init"), wxPoint(363, 163), wxSize(75, 25), 0, wxDefaultValidator, wxT("btnInit"));

	txtTrigThres = new wxStaticText(tabConfig, ID_TXTTRIGTHRES, wxT("Trigger Thres: 0.81V"), wxPoint(261, 168), wxDefaultSize, 0, wxT("txtTrigThres"));

	spinTriggerVoltage = new wxSpinCtrl(tabConfig, ID_SPINTRIGGERVOLTAGE, wxT("0"), wxPoint(192, 166), wxSize(67, 22), wxSP_ARROW_KEYS, 0, 4095, 0);

	wxArrayString arrayStringFor_boxTriggerSign;
	arrayStringFor_boxTriggerSign.Add(wxT("external, -"));
	arrayStringFor_boxTriggerSign.Add(wxT("external, +"));
	arrayStringFor_boxTriggerSign.Add(wxT("internal, -"));
	arrayStringFor_boxTriggerSign.Add(wxT("internal, +"));
	boxTriggerSign = new wxComboBox(tabConfig, ID_BOXTRIGGERSIGN, wxT("internal, -"), wxPoint(93, 166), wxSize(95, 21), arrayStringFor_boxTriggerSign, wxCB_READONLY, wxDefaultValidator, wxT("boxTriggerSign"));

	wxArrayString arrayStringFor_boxSamplingSpeed;
	arrayStringFor_boxSamplingSpeed.Add(wxT("10 GSa/s"));
	arrayStringFor_boxSamplingSpeed.Add(wxT("2.6 GSa/s"));
	arrayStringFor_boxSamplingSpeed.Add(wxT("5.1 GSa/s"));
	arrayStringFor_boxSamplingSpeed.Add(wxT("15.4 GSa/s"));
	boxSamplingSpeed = new wxComboBox(tabConfig, ID_BOXSAMPLINGSPEED, wxT("10 GSa/s"), wxPoint(11, 167), wxSize(77, 21), arrayStringFor_boxSamplingSpeed, wxCB_READONLY, wxDefaultValidator, wxT("boxSamplingSpeed"));

	btnLoadLUT = new wxButton(tabConfig, ID_BTNLOADLUT, wxT("Load LUT"), wxPoint(6, 7), wxSize(100, 25), 0, wxDefaultValidator, wxT("btnLoadLUT"));

	btnLoadPedestal = new wxButton(tabConfig, ID_BTNLOADPEDESTAL, wxT("Load Pedestal"), wxPoint(7, 41), wxSize(100, 25), 0, wxDefaultValidator, wxT("btnLoadPedestal"));

	txtFilenames = new wxStaticText(tabConfig, ID_TXTFILENAMES, wxT("^_^ (filename info)"), wxPoint(135, 7), wxDefaultSize, 0, wxT("txtFilenames"));

	spinPedVoltage = new wxSpinCtrl(tabConfig, ID_SPINPEDVOLTAGE, wxT("2048"), wxPoint(5, 122), wxSize(63, 22), wxSP_ARROW_KEYS, 0, 4096, 2048);

	txtPedVoltage = new wxStaticText(tabConfig, ID_TXTPEDVOLTAGE, wxT("? V"), wxPoint(75, 125), wxDefaultSize, 0, wxT("txtPedVoltage"));

	btnSetPedVoltage = new wxButton(tabConfig, ID_BTNSETPEDVOLTAGE, wxT("Set Ped Voltage"), wxPoint(131, 121), wxSize(100, 25), 0, wxDefaultValidator, wxT("btnSetPedVoltage"));

	tabStats = new wxPanel(boxReadoutMode, ID_TABSTATS, wxPoint(4, 24), wxSize(456, 207));
	boxReadoutMode->AddPage(tabStats, wxT("Statistics"));

	txtSpikeStats = new wxStaticText(tabStats, ID_TXTSPIKESTATS, wxT("Stats on spikes:"), wxPoint(12, 9), wxDefaultSize, 0, wxT("txtSpikeStats"));

	btnSaveSpikeHistogram = new wxButton(tabStats, ID_BTNSAVESPIKEHISTOGRAM, wxT("Save Spike Histogram"), wxPoint(9, 166), wxSize(131, 31), 0, wxDefaultValidator, wxT("btnSaveSpikeHistogram"));

	toggleCancel = new wxToggleButton(WxPanel1, ID_TOGGLECANCEL, wxT("Cancel"), wxPoint(5, 489), wxSize(162, 66), 0, wxDefaultValidator, wxT("toggleCancel"));
	toggleCancel->Show(false);
	toggleCancel->SetBackgroundColour(wxColour(wxT("RED")));

	WxStatusBar = new wxStatusBar(this, ID_WXSTATUSBAR);

	timerProbe = new wxTimer();
	timerProbe->SetOwner(this, ID_TIMERPROBE);
	timerProbe->Start(1000);

	SetStatusBar(WxStatusBar);
	SetTitle(wxT("PSEC3_eval"));
	SetIcon(wxNullIcon);
	SetSize(8,8,656,701);
	Center();
	
	////GUI Items Creation End
	int *widths = new int[STATUS_FIELDS];
	for(int i=1; i < STATUS_FIELDS; i++) {
	   widths[i] = (i + 1 == STATUS_FIELDS) ? 40 : 30;
    }
	widths[0] = -1;
	WxStatusBar->SetFieldsCount(STATUS_FIELDS, widths );
	delete[] widths;
	
	
	scope = new WaveformDisplay(this->pageGraph, 0, wxPoint(0,0), wxSize(632, 372));
	
	chOffset = 2;
	boxActiveChannel->SetSelection(0);
	
	wxSpinEvent evt;
	
	spinTriggerVoltageUpdated( evt );
    spinPedVoltageUpdated( evt );
    
    // init spike stats variables
    for(int i=0; i < CHANNELS; i++)
        chSpikes[i] = 0;
        
    for(int i=0; i < BUFFERSIZE; i++)
        bufferSpikes[i] = 0;
    
    totalReadouts = 0;
    eventNum = 0;
    fileEventNum = 0;
    
    LoadPedestal("pedestal.txt");
    LoadLUT("LUT.txt");
    UpdateLabels();

    scope->SetTimeBase(2.56);    

    ActiveChannels = 0xf;  // CH1-4 only at first
    
    ChannelOffsets[0] = 5;
    ChannelOffsets[1] = 2;
    ChannelOffsets[2] = -2;
    ChannelOffsets[3] = -5;
    
    for(int i=0; i < MAX_CHANNELS; i++)
        VerticalScale[i] = 0.1;
        
    sliderScale->SetValue(10);
    sliderOffset->SetValue(50);
    
    wxScrollEvent dummy;


    // TODO: find a better way around this - linux GL is picky
#ifndef LINUX    
    sliderOffsetScroll(dummy);
    sliderScaleScroll(dummy);
#endif

    Probe();
}

void PSEC3_evalFrm::OnClose(wxCloseEvent& event)
{
    // if we are reading data, kill it before quitting; this will also finish
    // writing the current event
    if (btnReadData->GetValue() ) {
        btnReadData->SetValue(false) ;   
    }
    
	Destroy();
}


/*
 * btnReadDataClick
 */
void PSEC3_evalFrm::btnReadDataClick(wxCommandEvent& event)
{
    do {
        if (! btnSyncUSB->GetValue() ) {
            in.createHandles();
            in.sendData(0x2);
            in.freeHandles();   
        }
        ReadData();
        wxYield();
    } while (btnReadData->GetValue() );

    
}

void PSEC3_evalFrm::ReadData() {
    int readoutsize = 1300;
    int read;

	in.createHandles();
    in.readData(this->buffer, readoutsize, &read);
	in.freeHandles();

    this->rawOutput->Clear();
    
    wxString rawText, numText;
    
    if (boxShowRawData->GetValue() ) {
    
        if (read > readoutsize) {
            rawText = numText = wxString::Format("Readout error - got %d bytes", read);        
        }
        else if (read >= 0) {
            rawText = numText = wxString::Format("Read %d bytes\n", read);
    
            rawText.Alloc(read * 7);
            
            for(int i=0; i < read; i++) {
                rawText += wxString::Format("%04x, ", buffer[i]);
                wxYield();
            }
    	}
    	else {
            rawText = numText = wxString::Format("Readout error - got %d bytes", read);        
        }            
    } 
    
    if (read < 1024 ) {
        if (!(btnSyncUSB->GetValue())) {
    		UPDATE_STATUS("Readout failed.");
            this->rawOutput->AppendText(rawText);
        }
		return;
	}
    
    this->rawOutput->AppendText(rawText);

//    bool hasSpike = false;
    for(int i=DATA_OFFSET; i < DATA_OFFSET+CHANNELS*CH_BUFFERSIZE; i++) {
        if ((buffer[i] & 0xf000) || (LUT[buffer[i] ][(i-DATA_OFFSET)/CH_BUFFERSIZE] < 0)) {
            bufferSpikes[i]++;
//            hasSpike = true;
            chSpikes[(i-DATA_OFFSET)/CH_BUFFERSIZE]++;
        }   
    }
    totalReadouts++;


    UpdateWaveforms();	
    LogData();    
    UpdateSpikeStats();
    
    // update event counter
    eventNum++;
    fileEventNum++;
    scopeEventNum = -1;
    UpdateLabels();
    
}

void PSEC3_evalFrm::UpdateWaveforms() {
    wxString data = "";
    for(int i=DATA_OFFSET; i < DATA_OFFSET + CHANNELS*CH_BUFFERSIZE; i++) {
        float signalValue, pedValue;
        
        int ch = (i - DATA_OFFSET)/CH_BUFFERSIZE;
        int idx = (i - DATA_OFFSET) % CH_BUFFERSIZE;

        if (buffer[i] < MAX_LUT && LUT[buffer[i] ][ch] >=0 ) {
            signalValue = LUT[buffer[i] ][ch];
            pedValue = LUT[ activePedestal[ch*CH_BUFFERSIZE + idx] ][ch];
            Waveform[i-DATA_OFFSET] = (float)(signalValue - pedValue);// * 50;
        } else {
            Waveform[i-DATA_OFFSET] = 50.0;
        }
    }

    scope->SetBuffer(Waveform);
    
    scope->SetActiveChannels(ActiveChannels);
    
    for(int i=0; i < MAX_CHANNELS; i++) {
        scope->SetOffset(i, ChannelOffsets[i]);
        scope->SetScale(VerticalScale[i], i);
    }
    
    scope->SetBufferSize(256);
    scope->Render();
       
}

/*
 * boxActiveChannelSelected
 */
void PSEC3_evalFrm::boxActiveChannelSelected(wxCommandEvent& event)
{
//    int val = boxActiveChannel->GetSelection();
//    chOffset = val * CH_BUFFERSIZE + DATA_OFFSET;
//    UpdateWaveforms();
    int ch = boxActiveChannel->GetSelection();
    int val;

    // enable status
    boxEnableCH->SetValue(ActiveChannels & (1 << ch));
    
    // offset
    val = (int)(ChannelOffsets[ch]*10.00001);  // .00001 in case result is x.99999
    sliderOffset->SetValue(val);
    
    // voltage
    val = (int)(VerticalScale[ch] * 100.0000001);
    sliderScale->SetValue(val);
    

    wxScrollEvent dummy;
    
    sliderOffsetScroll(dummy);
    sliderScaleScroll(dummy);

}

/*
 * btnCreatePedestalClick
 */
void PSEC3_evalFrm::btnCreatePedestalClick(wxCommandEvent& event)
{
    CreatePedestal();	

    UPDATE_STATUS("Pedestal created!");
    UPDATE_STATUSFIELD("PED*", STATUS_PED);
}

void PSEC3_evalFrm::CreatePedestal(int pedVoltage)
{
    
    in.createHandles();
    
    if (pedVoltage != -1) {
        unsigned int cmd = (pedVoltage << 16) | 0x3;
        in.sendData(cmd);

        // split up so that the user has a chance to click cancel
        //   if this function is called via LUT creation
        // waiting is necessary so the pedestal voltage can propogate on the board
        WxStatusBar->SetStatusText(wxString::Format("%d: Waiting for pedestal voltage to propogate...", pedVoltage) );
        
        for(int i=0; i < 20; i++) {
            wxMilliSleep(100);
            wxYield();   

            if (toggleCancel->GetValue() ) {
                in.freeHandles();   // clean up before cancelling
                return;
            }

        }
    }    
    

    
    const int PEDESTAL_ITERATIONS = 400;
    
    int pedValue[DATASIZE][PEDESTAL_ITERATIONS];
    
    for(int i=0; i < PEDESTAL_ITERATIONS; i++) {
        in.sendData(0x2);                   // trigger
        
        unsigned short buffer[1300];
        
        int count;
        in.readData(buffer, 1300, &count);
        
        if (count < BUFFERSIZE) {
            i--;
            continue;   
        }
        
        for(int j=0; j < DATASIZE; j++)
            pedValue[j][i] = buffer[j+DATA_OFFSET];
            
        if (pedVoltage != -1) 
            WxStatusBar->SetStatusText(wxString::Format("%d: Pedestal readout %d of %d", pedVoltage, i+1, PEDESTAL_ITERATIONS));
        else
            WxStatusBar->SetStatusText(wxString::Format("Pedestal readout %d of %d", i+1, PEDESTAL_ITERATIONS));

        
        wxYield();
    }
 
    
    for(int i=0; i < DATASIZE; i++) {
        sort(pedValue[i], pedValue[i]+PEDESTAL_ITERATIONS );
                        
        activePedestal[i] = pedValue[i][PEDESTAL_ITERATIONS/2];
    }

    in.freeHandles();
}

/*
 * btnCreateLutClick
 */
void PSEC3_evalFrm::btnCreateLutClick(wxCommandEvent& event)
{
    // inefficiency: save current LUT before starting.  this is because in case
    // the user decides to cancel, don't nuke current data
    float oldLUT[MAX_LUT][4];
    int oldPed[4*256];
    memcpy(oldLUT, LUT, sizeof(LUT) );
    memcpy(oldPed, activePedestal, sizeof(activePedestal) );
    
    for(int i=0; i < 4096; i++)
        LUT[i][0] = LUT[i][1] = LUT[i][2] = LUT[i][3] =  -1;

    toggleCancel->Show(true);
    // do DAC scans
    for(int i=10; i < 3511; i+=20) { 
        CreatePedestal(i);

        if (toggleCancel->GetValue() ) {
            toggleCancel->SetValue(false);

            memcpy(LUT, oldLUT, sizeof(LUT) );
            memcpy(activePedestal, oldPed, sizeof(activePedestal) );
            
            wxCommandEvent dummy;
            btnSetPedVoltageClick(dummy);
            
            Probe();
            wxMessageBox("LUT creation cancelled.  \nPlease check pedestal voltage value.");
            
            return;   
        }
        
        float voltage = i * 1.200/4096.0;
        
        for(int j=0; j < CHANNELS; j++) {
            int average = 0;
            
            for(int k=0; k < CH_BUFFERSIZE; k++)
                average += activePedestal[k+j*CH_BUFFERSIZE];
                
            average /= CH_BUFFERSIZE;    
            
            if (average > 0 && average < 4096)
                LUT[average][j] = voltage;
        }
        
    }
    toggleCancel->Show(false);

    // do interpolations
    int first, second, j;
    for(int i=0; i < 4; i++) {  // for each channel
        // find first value
        for(j=0; LUT[j][i] < 0; j++);  // don't test equality with floating point #s
        
        first = j;  // first is now the first LUT value
        
        while (j < 4096) {
            for(j++; LUT[j][i] < 0 && j < 4096; j++);
            
            if (j >= 4096) continue;
            
            second = j;
            
            for(int k=first+1; k < second; k++) {
                LUT[k][i] = LUT[first][i] + (float)(k-first)/(second-first) * (LUT[second][i] - LUT[first][i] );
            }

            first = second;
        }
    }
    
    UPDATE_STATUS("Lookup table (LUT) creation successful!");
    UPDATE_STATUSFIELD("LUT*", STATUS_LUT);

}

/*
 * btnSetPedVoltageClick
 */
void PSEC3_evalFrm::btnSetPedVoltageClick(wxCommandEvent& event)
{
	int val = spinPedVoltage->GetValue();
	
	in.createHandles();
	in.sendData(val << 16 | 0x3);
	in.freeHandles();
	
	UPDATE_STATUS("Pedestal voltage set.");
}

/*
 * spinPedVoltageUpdated
 */
void PSEC3_evalFrm::spinPedVoltageUpdated(wxSpinEvent& WXUNUSED(event) )
{
	int val = spinPedVoltage->GetValue();
	
	float voltage = val * 1.2/4096;
	txtPedVoltage->SetLabel(wxString::Format("%f V", voltage) );
}

/*
 * spinTriggerVoltageUpdated
 */
void PSEC3_evalFrm::spinTriggerVoltageUpdated(wxSpinEvent& WXUNUSED(event) )
{
	int val = spinTriggerVoltage->GetValue();
	
	float voltage = (float)val*1.2/4096;
	
	txtTrigThres->SetLabel(wxString::Format("Trigger Thres: %.2fV", voltage));
}

/*
 * btnInitClick
 */
void PSEC3_evalFrm::btnInitClick(wxCommandEvent& event)
{
	int thres, sign, samp;
	
	samp = boxSamplingSpeed->GetSelection();
	sign = boxTriggerSign->GetSelection();
	thres = spinTriggerVoltage->GetValue();
	
	unsigned int cmd = (samp << 30) | (sign << 28) | (thres << 16) | 0xff;
	
	in.createHandles();
    in.sendData(cmd);
    in.freeHandles();
    
    float times[4] = {2.56, 9.846, 5.02, 1.662};
    scope->SetTimeBase(times[samp]);
    scope->Render();
    
    UPDATE_STATUS("Init settings sent to board.");
}

/*
 * btnSingleEventClick
 */
void PSEC3_evalFrm::btnSingleEventClick(wxCommandEvent& event)
{
    in.createHandles();
    
    if (! btnSyncUSB->GetValue()) {
        in.sendData(0x2);
    }
    
    ReadData();
    
    in.freeHandles();
}

/*
 * btnSyncUSBClick
 */
void PSEC3_evalFrm::btnSyncUSBClick(wxCommandEvent& event)
{
    in.createHandles();
    if (btnSyncUSB->GetValue() )
        in.sendData(0x10001);
    else
        in.sendData(0x00001);
        
    in.freeHandles();
}

/*
 * btnLogDataClick
 */
void PSEC3_evalFrm::btnLogDataClick(wxCommandEvent& event)
{
    wxString outfileDir;
    
    if (btnLogData->GetValue() == false) {
        if (logFile == NULL) return;
        
        fclose(logFile);
        logFile = NULL;
        
        UpdateLabels();
        
        return;   
    }
    
    char c_filename[80];
    wxString filename;
    
    time_t now;
    time(&now);
    strftime(c_filename, 80, "logdata_%Y%m%d_%H%M%S.txt", localtime(&now));
    
    filename = wxString::Format(wxT("%s"), c_filename);
    
    wxFileDialog fdlg(this, wxT("Choose log file to save to"),
                      wxT(""), filename, wxT("Text file (*.txt)|*.txt|All files (*.*)|*.*"), wxFD_SAVE | wxOVERWRITE_PROMPT);
    
    if (wxID_CANCEL == fdlg.ShowModal()) {
        btnLogData->SetValue(false);  // if user cancels, we aren't logging data
        return;
    }
    
    outfileDir = fdlg.GetDirectory();
    logFile = fopen(fdlg.GetPath().ToAscii(), "w");
    
    fileEventNum = 0;

    UpdateLabels();
    
}

void PSEC3_evalFrm::LogData() {
    if (btnLogData->GetValue() == false)
        return;
        
    for(int i=2; i < 1026; i++)
        fprintf(logFile, "%d\n", buffer[i]);
    
    fprintf(logFile, "\n");
    
    fflush(logFile);
}

void PSEC3_evalFrm::UpdateSpikeStats() {
    wxString result = "";
    
    result += wxString::Format("Total readouts: %d\nCH1: %d\nCH2: %d\nCH3: %d\nCH4: %d", totalReadouts, chSpikes[0], 
        chSpikes[1], chSpikes[2], chSpikes[3]);
    
    txtSpikeStats->SetLabel(result);
}

/*
 * btnSaveSpikeHistogramClick
 */
void PSEC3_evalFrm::btnSaveSpikeHistogramClick(wxCommandEvent& event)
{
    FILE* fout = fopen("spikehist.txt", "w");
    
    for(int i=0; i < CHANNELS; i++)
        for(int j=0; j < CH_BUFFERSIZE; j++)
            fprintf(fout, "%d\n", bufferSpikes[DATA_OFFSET + j + i*CH_BUFFERSIZE] );

    fclose(fout);
}

/*
 * btnExitClick
 */
void PSEC3_evalFrm::btnExitClick(wxCommandEvent& event)
{
    Close();
}

/*
 * btnResetEventCounterClick
 */
void PSEC3_evalFrm::btnResetEventCounterClick(wxCommandEvent& event)
{
    eventNum = 0;
    UpdateLabels();
}


void PSEC3_evalFrm::UpdateLabels() {
    wxString evtLbl = wxString::Format("Event #: %d\nEvent # on board: %hd", eventNum, buffer[1032]);
    wxString scopeInfo;
    
    if (btnLogData->GetValue() )
        evtLbl += wxString::Format("\nEvents in file: %d", fileEventNum);
    
    txtEvent->SetLabel( evtLbl);
    
    if (scopeEventNum == -1)
        scopeInfo = "Display: USB";
    else
        // diabled since filename may be really long
        //        scopeInfo = "Display: " + filenameLog + ": " + wxString::Format("%d", scopeEventNum+1);
        scopeInfo = "Display: file:" + wxString::Format("%d", scopeEventNum+1);
            
    txtFilenames->SetLabel(wxT("LUT: ") + filenameLUT + wxT("\nPedestal: ") + filenamePed + wxT("\n") + scopeInfo);
}

/*
 * btnLoadLogFileClick
 */
void PSEC3_evalFrm::btnLoadLogFileClick(wxCommandEvent& event)
{
    wxString filename, part = "";
    
    wxFileDialog fdlg(this, wxT("Choose log file to open"),
                      wxT(""), filename, wxT("Text file (*.txt)|*.txt|All files (*.*)|*.*"), wxFD_OPEN);
    
    if (fdlg.ShowModal() == wxID_CANCEL)
        return;
      
    filename = fdlg.GetPath();
    
    int total, partTotal;
    total = logData.LoadFile(filename.To8BitData() );
    
    toggleCancel->Show(true);
    while ( (partTotal = logData.ContinueLoadingFile(100) ) > 0 ) {
        total += partTotal;
        this->WxStatusBar->SetStatusText(wxString::Format( "Loading events... %d", total  )); 
        wxYield();

        if (toggleCancel->GetValue() ) {
            toggleCancel->SetValue(false);
            part = " (partial)";
            
            break;   
        }
    }
    toggleCancel->Show(false);

    UPDATE_STATUS( wxString::Format("Loaded %d events from " + fdlg.GetFilename() + part, total) );
    
//    wxMessageBox(wxString::Format("%d entries " + part, total) );
    
    filenameLog = fdlg.GetFilename();

    if (total > 0) {
        wxScrollEvent dummy;

        logData.EventSeek(0);
        barSelectEvent->Enable(true);
        barSelectEvent->SetRange(total);
        barSelectEvent->SetThumbPosition(0);
        barSelectEventScroll(dummy);
    }
    else
        barSelectEvent->Enable(false);
    
    UpdateLabels();
}

/*
 * barSelectEventScroll
 */
void PSEC3_evalFrm::barSelectEventScroll(wxScrollEvent& WXUNUSED(event) )
{
	int curr, max;
	
	curr = barSelectEvent->GetThumbPosition();
	max = barSelectEvent->GetRange();
	
	scopeEventNum = curr;
	
	int read = logData.EventSeek(curr);
	
	txtEventNum->SetLabel( filenameLog + wxString::Format(" - Event %d/%d", curr+1, max) );

    // this part is stolen from ReadData and adapted
    unsigned short *tmpBuffer = logData.getBuffer();
    for(int i=0; i < read; i++)
        buffer[i] = tmpBuffer[i];


    if (boxShowRawData->GetValue() ) {
        this->rawOutput->Clear();
        
        wxString rawText, numText;
        
        rawText = numText = wxString::Format("Read %d bytes\n", read);
    
        rawText.Alloc(read * 7);
        
        for(int i=0; i < read; i++) {
            rawText += wxString::Format("%04x, ", buffer[i]);
            wxYield();
        }
        
        this->rawOutput->AppendText(rawText);
    }

    for(int i=DATA_OFFSET; i < DATA_OFFSET+CHANNELS*CH_BUFFERSIZE; i++) {
        if ((buffer[i] & 0xf000) || (LUT[buffer[i] ][(i-DATA_OFFSET)/CH_BUFFERSIZE] < 0)) {
            bufferSpikes[i]++;
            chSpikes[(i-DATA_OFFSET)/CH_BUFFERSIZE]++;
        }   
    }
    totalReadouts++;

    UpdateWaveforms();	
    UpdateLabels();
}

/*
 * sliderOffsetScroll
 */
void PSEC3_evalFrm::sliderOffsetScroll(wxScrollEvent& event)
{
    int pos = sliderOffset->GetValue();
    int ch = boxActiveChannel->GetSelection();
    
    if (ch < 0) return; // no channel selected
    
    ChannelOffsets[ch] = (float)pos/10;
    scope->SetOffset(ch, ChannelOffsets[ch]);
    scope->Render();
    
    txtOffset->SetLabel(wxString::Format("Vertical Offset: %.2f", ChannelOffsets[ch]) );
}

/*
 * boxEnableCHClick
 */
void PSEC3_evalFrm::boxEnableCHClick(wxCommandEvent& event)
{
    int ch = boxActiveChannel->GetSelection();
    
    if (ch < 0) return; // no channel selected

    ActiveChannels ^= (1 << ch);
    
    scope->SetActiveChannels(ActiveChannels);
    scope->Render();
}

/*
 * btnCopySignalClick
 */
void PSEC3_evalFrm::btnCopySignalClick(wxCommandEvent& event)
{
    int ch = boxActiveChannel->GetSelection();
    wxString choices[4] = {"Saved1", "Saved2", "Saved3", "Saved4"};   
    
    if (ch < 0) return; // no channel selected
    
    int targetChannel = wxGetSingleChoiceIndex("Copy signal to which channel?", "!", wxArrayString(4, choices) );
    
    if (targetChannel == -1) return;
    
    targetChannel += 4;  // correspond to a saved channel
    
    for(int i=0; i < CH_BUFFERSIZE; i++)
        Waveform[targetChannel*CH_BUFFERSIZE + i] = Waveform[ch*CH_BUFFERSIZE + i];
    
    scope->SetScale(VerticalScale[ch], targetChannel);
    
    scope->Render();
}

/*
 * sliderScaleScroll
 */
void PSEC3_evalFrm::sliderScaleScroll(wxScrollEvent& event)
{
    int ch = boxActiveChannel->GetSelection();
    if (ch < 0) return; // no channel selected
    
    float scale;
    scale = sliderScale->GetValue()/100.0;
    
    VerticalScale[ch] = scale;
    scope->SetScale(scale, ch);
    scope->Render();
    
    txtScaling->SetLabel(wxString::Format("Vertical scaling: %d mV/div", sliderScale->GetValue()*10) );
}

/*
 * btnLoadPedestalClick
 */
void PSEC3_evalFrm::btnLoadPedestalClick(wxCommandEvent& event)
{
    wxFileDialog fdlg(this, wxT("Choose pedestal file to load"),
                      wxT(""), "pedestal.txt", wxT("Text file (*.txt)|*.txt|All files (*.*)|*.*"), wxFD_OPEN | wxFD_FILE_MUST_EXIST);
    
    if (wxID_CANCEL == fdlg.ShowModal()) {
        return;
    }
    
    LoadPedestal(fdlg.GetPath().ToAscii() );
    
    UPDATE_STATUS("Pedestal file " + fdlg.GetFilename() + " loaded.");
}

void PSEC3_evalFrm::LoadPedestal(wxString filename) {
    FILE* fout = fopen(filename.c_str(), "r");
    if (fout == NULL) return;
    
    for(int i=0; i < DATASIZE; i++)
        if (0 == fscanf(fout, "%d\n", &activePedestal[i]) ) {
            // invalid file
            wxMessageBox("Invalid pedestal file.");
            return;   
        }
    
    fclose(fout);
   
    filenamePed = filename.AfterLast('\\');
    filenamePed = filenamePed.AfterLast('/');  // don't know if it is UNIX or windows
                                                // but we truncate in either case
    UpdateLabels();
    WxStatusBar->SetStatusText("PED", STATUS_PED);
}

/*
 * btnSavePedestalClick
 */
void PSEC3_evalFrm::btnSavePedestalClick(wxCommandEvent& event)
{
    wxString outfileDir;
    wxString filename;
    
    wxFileDialog fdlg(this, wxT("Choose pedestal file to save to"),
                      wxT(""), "pedestal.txt", wxT("Text file (*.txt)|*.txt|All files (*.*)|*.*"), wxFD_SAVE | wxOVERWRITE_PROMPT);
    
    if (wxID_CANCEL == fdlg.ShowModal()) {
        return;
    }
    
    FILE* fout = fopen(fdlg.GetPath().ToAscii(), "w");
	
	for(int i=0; i < DATASIZE; i++)
	   fprintf(fout, "%d\n", activePedestal[i]);
	   
	fclose(fout);

    UPDATE_STATUS("Pedestal saved to " + fdlg.GetPath() );

    wxString txt = WxStatusBar->GetStatusText(STATUS_PED);
    txt.Replace("*", "");
    WxStatusBar->SetStatusText( txt , STATUS_PED);
}

/*
 * btnLoadLUTClick
 */
void PSEC3_evalFrm::btnLoadLUTClick(wxCommandEvent& event)
{
    wxFileDialog fdlg(this, wxT("Choose LUT file to load"),
                      wxT(""), "LUT.txt", wxT("Text file (*.txt)|*.txt|All files (*.*)|*.*"), wxFD_OPEN | wxFD_FILE_MUST_EXIST);
    
    if (wxID_CANCEL == fdlg.ShowModal()) {
        return;
    }
    
    LoadLUT(fdlg.GetPath().ToAscii());
    UPDATE_STATUS("LUT file " + fdlg.GetFilename() + " loaded.");
}

void PSEC3_evalFrm::LoadLUT(wxString filename) {
    FILE* fout = fopen(filename.c_str(), "r");

    if (fout == NULL)
        return;
    
    int rows=0;
    
    while (!feof(fout)) {
        int i;
        char buf[1000];
        
        fgets(buf, 1000, fout);
        
        if (feof(fout))
            continue;
            
        if (count(buf, buf + strlen(buf), '\t') < 4)
            continue;  // not 5-column or more
        
        sscanf(buf, "%d\t", &i);
        
        int tmp;
        sscanf(buf, "%d\t%f\t%f\t%f\t%f\t\n", &tmp, &LUT[i][0], &LUT[i][1], &LUT[i][2], &LUT[i][3] );
        rows++;
    }

    fclose(fout);
    
    if (rows < 10) {
        wxMessageBox("Invalid LUT file.");
        return;
    }
    
    filenameLUT = filename.AfterLast('\\');
    filenameLUT = filenameLUT.AfterLast('/');  // don't know if it is UNIX or windows
                                                // but we truncate in either case

    UpdateLabels();
    
    WxStatusBar->SetStatusText("LUT", STATUS_LUT);
}

/*
 * btnSaveLUTClick
 */
void PSEC3_evalFrm::btnSaveLUTClick(wxCommandEvent& event)
{
    wxString outfileDir;
    wxString filename;
    
    wxFileDialog fdlg(this, wxT("Choose LUT file to save to"),
                      wxT(""), "LUT.txt", wxT("Text file (*.txt)|*.txt|All files (*.*)|*.*"), wxFD_SAVE | wxOVERWRITE_PROMPT);
    
    if (wxID_CANCEL == fdlg.ShowModal()) {
        return;
    }
    
    FILE* fout = fopen(fdlg.GetPath().ToAscii(), "w");
    for(int i=0; i < 4096; i++)
        fprintf(fout, "%d\t%f\t%f\t%f\t%f\t\n", i, LUT[i][0], LUT[i][1], LUT[i][2], LUT[i][3] );
    
    fclose(fout);    
    
    UPDATE_STATUS("LUT saved to " + fdlg.GetPath() );
    
    wxString txt = WxStatusBar->GetStatusText(STATUS_LUT);
    txt.Replace("*", "");
    WxStatusBar->SetStatusText( txt , STATUS_LUT);
    
}

void PSEC3_evalFrm::Probe() {
    if (in.isOpen() ) {
        // don't do anything, there is likely another USB operation in progress
        return;   
    }

    if (stdUSB::SUCCEED == in.createHandles() ) {
        in.freeHandles();
//        WxStatusBar->SetLabel("Ready.");    
//        UPDATE_STATUS("Ready.");
        UPDATE_STATUSFIELD( "USB" , STATUS_USB);
    }
    else
    {
//        WxStatusBar->SetLabel("USB connection missing.");            
        UPDATE_STATUSFIELD( " " , STATUS_USB);
    }   
}

/*
 * toggleCancelClick
 */
void PSEC3_evalFrm::toggleCancelClick(wxCommandEvent& event)
{
    UPDATE_STATUS("Cancel in progress...");
	// insert your code here
}

/*
 * timerProbeTimer
 */
void PSEC3_evalFrm::timerProbeTimer(wxTimerEvent& event)
{
    Probe();
}
