//---------------------------------------------------------------------------
//
// Name:        PSEC3_evalFrm.h
// Author:      Andrew Wong
// Created:     2/6/2008 4:51:21 PM
// Description: PSEC3_evalFrm class declaration
//
//---------------------------------------------------------------------------

#ifndef __PSEC3_evalFRM_h__
#define __PSEC3_evalFRM_h__

#ifdef __BORLANDC__
	#pragma hdrstop
#endif

#ifndef WX_PRECOMP
	#include <wx/wx.h>
	#include <wx/frame.h>
#else
	#include <wx/wxprec.h>
#endif

//Do not add custom headers between 
//Header Include Start and Header Include End.
//wxDev-C++ designer will remove them. Add custom headers after the block.
////Header Include Start
#include <wx/timer.h>
#include <wx/statusbr.h>
#include <wx/combobox.h>
#include <wx/spinctrl.h>
#include <wx/statbox.h>
#include <wx/slider.h>
#include <wx/listbox.h>
#include <wx/scrolbar.h>
#include <wx/tglbtn.h>
#include <wx/stattext.h>
#include <wx/button.h>
#include <wx/checkbox.h>
#include <wx/textctrl.h>
#include <wx/notebook.h>
#include <wx/panel.h>
////Header Include End

#include <vector>
#include <algorithm>
using namespace std;

#include <wx/dir.h>

#include "stdUSB.h"
#include "WaveformDisplay.h"
#include "OfflineEventViewer.h"
#include "iniparser.h"
#include "defs.h"

////Dialog Style Start
#undef PSEC3_evalFrm_STYLE
#define PSEC3_evalFrm_STYLE wxCAPTION | wxSYSTEM_MENU | wxMINIMIZE_BOX | wxCLOSE_BOX
////Dialog Style End

class PSEC3_evalFrm : public wxFrame
{
	private:
		DECLARE_EVENT_TABLE();
		
	public:
		PSEC3_evalFrm(wxWindow *parent, wxWindowID id = 1, const wxString &title = wxT("PSEC3_eval"), const wxPoint& pos = wxDefaultPosition, const wxSize& size = wxDefaultSize, long style = PSEC3_evalFrm_STYLE);
		virtual ~PSEC3_evalFrm();
		void WxPanel1UpdateUI(wxUpdateUIEvent& event);
		void btnSendCommandClick(wxCommandEvent& event);
		void btnReadDataClick(wxCommandEvent& event);
		void btnFindReadoutSizeClick(wxCommandEvent& event);
		void listCommandsSelected(wxCommandEvent& event );
		void boxPresetSelected(wxCommandEvent& event );
		void btnSaveSettingsClick(wxCommandEvent& event);
		void boxActiveChannelSelected(wxCommandEvent& event);
		void btnCreatePedestalClick(wxCommandEvent& event);
		void btnCreateLutClick(wxCommandEvent& event);
		void btnLoadLUTClick(wxCommandEvent& event);
		void btnSetPedVoltageClick(wxCommandEvent& event);
		void spinPedVoltageUpdated(wxSpinEvent& event );
		void btnSavePedestalClick(wxCommandEvent& event);
		void spinTriggerVoltageUpdated(wxSpinEvent& event );
		void btnInitClick(wxCommandEvent& event);
		void btnSingleEventClick(wxCommandEvent& event);
		void btnSyncUSBClick(wxCommandEvent& event);
		void brnLoadPedestalClick(wxCommandEvent& event);
		void btnLoadPedestalClick(wxCommandEvent& event);
		void btnLogDataClick(wxCommandEvent& event);
		void btnSaveSpikeHistogramClick(wxCommandEvent& event);
		void btnExitClick(wxCommandEvent& event);
		void btnResetEventCounterClick(wxCommandEvent& event);
		void btnLoadLogClick(wxCommandEvent& event);
		void btnLoadLogFileClick(wxCommandEvent& event);
		void barSelectEventScroll(wxScrollEvent& event);
		void sliderOffsetScroll(wxScrollEvent& event);
		void boxEnableCHClick(wxCommandEvent& event);
		void btnCopySignalClick(wxCommandEvent& event);
		void sliderScaleScroll(wxScrollEvent& event);
		void btnSaveLUTClick(wxCommandEvent& event);
		void toggleCancelClick(wxCommandEvent& event);
		void timerProbeTimer(wxTimerEvent& event);
		
	private:
		//Do not add custom control declarations between
		//GUI Control Declaration Start and GUI Control Declaration End.
		//wxDev-C++ will remove them. Add custom code after the block.
		////GUI Control Declaration Start
		wxTimer *timerProbe;
		wxStatusBar *WxStatusBar;
		wxToggleButton *toggleCancel;
		wxButton *btnSaveSpikeHistogram;
		wxStaticText *txtSpikeStats;
		wxPanel *tabStats;
		wxButton *btnSetPedVoltage;
		wxStaticText *txtPedVoltage;
		wxSpinCtrl *spinPedVoltage;
		wxStaticText *txtFilenames;
		wxButton *btnLoadPedestal;
		wxButton *btnLoadLUT;
		wxComboBox *boxSamplingSpeed;
		wxComboBox *boxTriggerSign;
		wxSpinCtrl *spinTriggerVoltage;
		wxStaticText *txtTrigThres;
		wxButton *btnInit;
		wxStaticBox *grpInit;
		wxPanel *tabConfig;
		wxButton *btnCopySignal;
		wxSlider *sliderScale;
		wxStaticText *txtScaling;
		wxCheckBox *boxEnableCH;
		wxSlider *sliderOffset;
		wxStaticText *txtOffset;
		wxListBox *boxActiveChannel;
		wxPanel *tabScope;
		wxStaticText *txtEventNum;
		wxScrollBar *barSelectEvent;
		wxButton *btnLoadLogFile;
		wxPanel *tabOffline;
		wxButton *btnSaveLUT;
		wxToggleButton *btnReadData;
		wxButton *btnSingleEvent;
		wxToggleButton *btnSyncUSB;
		wxToggleButton *btnLogData;
		wxButton *btnResetEventCounter;
		wxStaticText *txtEvent;
		wxButton *btnCreateLut;
		wxButton *btnSavePedestal;
		wxButton *btnCreatePedestal;
		wxPanel *tabOnline;
		wxNotebook *boxReadoutMode;
		wxButton *btnExit;
		wxCheckBox *boxShowRawData;
		wxTextCtrl *rawOutput;
		wxPanel *pageOutput;
		wxPanel *pageGraph;
		wxNotebook *boxDisplay;
		wxPanel *WxPanel1;
		////GUI Control Declaration End
		
	private:
		//Note: if you receive any error with these enum IDs, then you need to
		//change your old form code that are based on the #define control IDs.
		//#defines may replace a numeric value for the enum names.
		//Try copy and pasting the below block in your old form header files.
		enum
		{
			////GUI Enum Control ID Start
			ID_TIMERPROBE = 1146,
			ID_WXSTATUSBAR = 1024,
			ID_TOGGLECANCEL = 1075,
			ID_BTNSAVESPIKEHISTOGRAM = 1139,
			ID_TXTSPIKESTATS = 1138,
			ID_TABSTATS = 1081,
			ID_BTNSETPEDVOLTAGE = 1145,
			ID_TXTPEDVOLTAGE = 1144,
			ID_SPINPEDVOLTAGE = 1143,
			ID_TXTFILENAMES = 1137,
			ID_BTNLOADPEDESTAL = 1136,
			ID_BTNLOADLUT = 1135,
			ID_BOXSAMPLINGSPEED = 1132,
			ID_BOXTRIGGERSIGN = 1131,
			ID_SPINTRIGGERVOLTAGE = 1130,
			ID_TXTTRIGTHRES = 1129,
			ID_BTNINIT = 1128,
			ID_GRPINIT = 1133,
			ID_TABCONFIG = 1080,
			ID_BTNCOPYSIGNAL = 1091,
			ID_SLIDERSCALE = 1089,
			ID_TXTSCALING = 1088,
			ID_BOXENABLECH = 1087,
			ID_SLIDEROFFSET = 1086,
			ID_TXTOFFSET = 1085,
			ID_BOXACTIVECHANNEL = 1083,
			ID_TABSCOPE = 1082,
			ID_TXTEVENTNUM = 1071,
			ID_BARSELECTEVENT = 1070,
			ID_BTNLOADLOGFILE = 1069,
			ID_TABOFFLINE = 1047,
			ID_BTNSAVELUT = 1079,
			ID_BTNREADDATA = 1068,
			ID_BTNSINGLEEVENT = 1067,
			ID_BTNSYNCUSB = 1066,
			ID_BTNLOGDATA = 1063,
			ID_BTNRESETEVENTCOUNTER = 1062,
			ID_TXTEVENT = 1061,
			ID_BTNCREATELUT = 1051,
			ID_BTNSAVEPEDESTAL = 1050,
			ID_BTNCREATEPEDESTAL = 1048,
			ID_TABONLINE = 1046,
			ID_BOXREADOUTMODE = 1045,
			ID_BTNEXIT = 1041,
			ID_BOXSHOWRAWDATA = 1147,
			ID_RAWOUTPUT = 1010,
			ID_PAGEOUTPUT = 1005,
			ID_PAGEGRAPH = 1003,
			ID_BOXDISPLAY = 1002,
			ID_WXPANEL1 = 1001,
			////GUI Enum Control ID End
			ID_DUMMY_VALUE_ //don't remove this value unless you have other enum values
		};
		
	private:
        OfflineEventViewer logData;
        
		void OnClose(wxCloseEvent& event);
		void CreateGUIControls();
		
		float Waveform[256*16];
		
		int activePedestal[4*256];
		short unsigned int buffer[1300];
		float LUT[MAX_LUT][4];
		WaveformDisplay *scope;
		
		int chSpikes[CHANNELS];
		int bufferSpikes[BUFFERSIZE];
		int totalReadouts;
	    void UpdateSpikeStats();

        vector<int> hiCmd;
        vector<int> loCmd;
		
		void ReadData();
		void LogData();
		
		void UpdateWaveforms();
		void CreatePedestal(int pedVoltage = -1);
		void Probe();
		
		
		int chOffset;
		
		stdUSB in;
		FILE* logFile;
		
		int eventNum;
		int fileEventNum;
		int scopeEventNum;  // -2 for blank display, -1 if from board, # if isn't
		
		void LoadLUT(wxString filename);
		void LoadPedestal(wxString filename);
		void UpdateLabels();
		
		wxString filenameLUT;
		wxString filenamePed;
		wxString filenameLog;

        unsigned int ActiveChannels;
        float ChannelOffsets[MAX_CHANNELS];
        float VerticalScale[MAX_CHANNELS];
};

#endif
